<?php

namespace Opentalent\OtAdmin\Command;


use Opentalent\OtAdmin\Controller\SiteController;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;

/**
 * This CLI command resets the permissions granted to
 * this website be users
 *
 * @package Opentalent\OtAdmin\Command
 */
class ResetBeUserPermsCommand extends Command
{
    public function __construct(
        private readonly SiteController $siteController,
        private readonly ConnectionPool $connectionPool
    ) {
        parent::__construct();
    }

    /**
     * -- This method is expected by Typo3, do not rename ou remove --
     *
     * Allows to configure the command.
     * Allows to add a description, a help text, and / or define arguments.
     *
     */
    protected function configure()
    {
        $this
            ->setName("ot:site:reset-perms")
            ->setDescription("Reset the permissions granted to the be users")
            ->setHelp("This CLI command resets the permissions granted to 
                            either one website be users, or every websites be users")
            ->addArgument(
                'organization-id',
                InputArgument::OPTIONAL,
                "The organization's id in the opentalent DB"
            )
            ->addOption(
                "all",
                null,
                InputOption::VALUE_NONE,
                "Reset all of the websites be_users permissions."
            )
            ->addOption(
                "create",
                'c',
                InputOption::VALUE_NONE,
                "Create the be_user and/or be_group when they are missing"
            );
    }

    /**
     * -- This method is expected by Typo3, do not rename ou remove --
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int
     * @throws \Exception
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $org_id = $input->getArgument('organization-id');
        $all = $input->getOption('all');
        $create = $input->getOption('create');

        if ($all && $org_id) {
            throw new \InvalidArgumentException("You can not pass both an organization id and the --all option");
        }
        if (!$all && !$org_id) {
            throw new \InvalidArgumentException("You shall either pass an organization id or use the --all option");
        }

        $io = new SymfonyStyle($input, $output);

        if ($all) {
            $queryBuilder = $this->connectionPool->getQueryBuilderForTable('ot_websites');
            $sites = $queryBuilder
                ->select('organization_id')
                ->from('ot_websites')
                ->where($queryBuilder->expr()->eq('deleted', 0))
                ->andWhere($queryBuilder->expr()->gt('organization_id', 0))
                ->execute()
                ->fetchAll();

            $io->progressStart(count($sites));

            foreach ($sites as $site) {
                $org_id = $site['organization_id'];
                try {
                    $this->siteController->resetBeUserPermsAction($org_id, $create);
                } catch (\Throwable $e) {
                    $io->error('Organization Id: ' . $org_id . ' - ' . $e->getMessage());
                }
                $io->progressAdvance(1);
            }
            $io->progressFinish();

            $io->success(sprintf("Be users permissions were reset for every website"));
        } else {
            $rootUid = $this->siteController->resetBeUserPermsAction($org_id, $create);
            $io->success(sprintf("The website with root uid " . $rootUid . " had its be users permissions reset"));
        }
        return 0;
    }

}
